/***************************************************************************
   kttdoc.h  -  KTTDoc

   begin     : 2002.11.08
   copyright : (C) 2002 by MiMaS
   email     : mimas@mimas.ceti.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KTTDOC_H
#define KTTDOC_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for QT
#include <qobject.h>
#include <qstring.h>

// include files for KDE
#include <kurl.h>

// application specific includes
#include "resources.h"
#include "kttview.h"


class KTTDoc : public QObject
{
  Q_OBJECT
  public:
    KTTDoc(QWidget *parent, const char *name=0);
    ~KTTDoc();

    void addView(KTTView *view);

    bool newDocument();
    void closeDocument();
    bool saveModified();
    bool openDocument(const KURL& url, const int type);
    bool saveDocument(const KURL& url, const int type);

    void setModifiedRoman(bool yes)   { pView->setModifiedRoman(yes);   };
    void setModifiedTengwar(bool yes) { pView->setModifiedTengwar(yes); };
    bool isModifiedRoman()   const { return pView->isModifiedRoman();   };
    bool isModifiedTengwar() const { return pView->isModifiedTengwar(); };
    
    const KURL& URL(const int type) const;

  public slots:
    void slotUpdateAllViews(KTTView *sender);

  public:	
    KTTView *pView;

  private:
    bool saveModifiedType(int type);
  
    KURL doc_url_tengwar;
    KURL doc_url_roman;
};

#endif // KTTDOC_H
